hdu1087 Super Jumping! Jumping! Jumping!

Super Jumping! Jumping! Jumping!


Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 29303    Accepted Submission(s): 13092




Problem Description
Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.






The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
Your task is to output the maximum value according to the given chessmen list.
 


Input
Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N 
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
A test case starting with 0 terminates the input and this test case is not to be processed.
 


Output
For each case, print the maximum according to rules, and one line one case.
 


Sample Input
3 1 3 2
4 1 2 3 4
4 3 3 2 1
0
 


Sample Output
4
10
3


题目的大意是从起点开始跳,只能从小到大跳不能从大到小跳,也可以直接从起点跳到终点,并假设起点最小,终点最大,可以一次跳一步也可以一次跳任意多步,问途径的数组的最大和是多少,这个和最长上升子序列其实没什么本质区别,只不过最长上升子序列是求一个长度,也就是说cou = 0然后cou++这种模式,然而此题是把计数器变成sum求和而已


#include <cstdio>
#include <algorithm>
#include <iostream>
#include <cstdlib>
#include <cstring>

using namespace std;

int a[1005];
int dp[1005];  //dp用来存当前状态的最大和
int sizedp = sizeof(dp);

int main()
{
	int N;
	while (~scanf("%d", &N) && N) {
		for (int i = 0; i < N; i++) {
			scanf("%d", &a[i]);
		}
		int ans = 0;   //初始最大和为0
		memset(dp, 0, sizedp);
		for (int i = 0; i < N; i++) {
			int maxn = 0;
			for (int j = 0; j < i; j++) {   //找i之前的且比a[i]小的中dp的最大值(因为是上升子序列)
				if (a[j] < a[i]) {
					maxn = max(maxn, dp[j]);
				}
			}
			dp[i] = maxn + a[i];  //状态转移方程,当前最优解为上一个最优解加当前a[i]值
			ans = max(ans, dp[i]);  //ans要保留所有上升子序列和的最大值
		}
		printf("%d\n", ans);
	}
	return 0;
}


你可能感兴趣的:(算法,dp,动态规划,ACM,hduoj)